package HMS;
use strict;
use XML::Simple;
use CGI;
use CGI::URI2param;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;


sub new {
	my($c)=shift;
	my($s)={
		_version	=> '$Id$',
		_extension	=> "",
		_skin		=> "default",
		_xml		=> XML::Simple->new,
		_cgi		=> CGI->new,
	};
	bless($s,$c);
	$s->{_self}=$ENV{SCRIPT_NAME};
	$s->{_self}=~s/\/+$//g;
	$s;
}

sub xml { $_[0]->{_xml} }
sub cgip { $_[0]->{_cgip} }
sub cgi { $_[0]->{_cgi} }

sub load {
	my($s)=shift;
	$s->{html}="test\n";
}

sub loadFile {
	my($s)=shift;
	my($page)=@_;
}

sub loadMenu {
	my($s)=shift;
	my($menu)=($s->xml->XMLin("./data/menu.xml",keyattr=>""))->{menu};
	my($cnt,$ent);
	foreach(@{$menu}) {
		if($cnt==$#{$menu}) {
			$_->{last}=1;
			push(@{$ent},{space=>"&nbsp;",last=>1})
		}
		else {
			push(@{$ent},{space=>"&nbsp;"})
		}
		if($_->{url} eq $s->{_page}) {
			$_->{active}=1;
		}
		$_->{url}.=$s->{_extension};
		$cnt++;
	}
	($menu,$ent)
}

sub loadPage {
	my($s)=shift;
	my($page)=shift||"home";
	my($content)=$s->xml->XMLin("./data/$page.xml");
	print "Content-type: text/html\n\n".$s->loadTemplate($content);
}

sub loadTemplate {
	my($s)=shift;
	my($page)=@_;
	my($t)=HTML::Template->new(filename=>"./skins/$s->{_skin}/template.html");
	my($menu,$ent)=$s->loadMenu;
	$t->param(
		TITLE		=> $page->{title},
		MENU		=> $menu,
		ENTRIES		=> $ent,
		CONTENT		=> $page->{content},
	);
	$t->output
}

sub printStyle {
	my($s)=shift;
	my($style)=shift;
	$style=$s->cleanPath($style);
	print "Content-type: text/css\n\n";
	open(STYLE,"./skins/$s->{_skin}/styles/$style.css");
	print foreach(<STYLE>);
	close(STYLE);
}

sub printImage {
	my($s)=shift;
	my($file,$ext)=@_;
	$file=$s->cleanPath($file);
	print "Content-type: image/$ext\n\n";
	open(IMG,"./skins/$s->{_skin}/images/$file.$ext");
	binmode(IMG);
	print foreach(<IMG>);
	close(IMG);
}

sub cleanPath {
	my($s)=shift;
	my($path)=shift;
	$path=~s!(\.+/)+!!g;
	$path=~s!/+!/!g;
	$path=~s!^/+!!;
	$path
}

sub loadPlugin {
	my($s)=shift;
	my($name)=shift;
	eval "use HMS::$name";
	eval "\$s->{_$name}=HMS::$name->new(\\\$s)";
	eval "sub $name {\$_[0]->{_$name}}";
}

sub uri2param {
	my($s)=shift;
	my($regex)=shift;
	CGI::URI2param::uri2param($s->{_cgi},$regex);
}

1;

package HMS::DataFiles;
use strict;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use MIME::Types;

sub new {
	my($c)=shift;
	my($s)={
		_base		=> ${$_[0]},
	};
	bless($s,$c)
}

sub base { $_[0]->{_base} }
sub xml { $_[0]->{_base}->{_xml} }

sub setPathPrefix { $_[0]->{_path_prefix}=$_[1] }
sub setName { $_[0]->{_name}=$_[1] }
sub setTemplate { $_[0]->{_template}=$_[1] }

sub loadPage {
	my($s)=shift;
	my($page)=shift||"";
	my($content)=$s->getList($page);
	print "Content-type: text/html\n\n".$s->base->loadTemplate($content);

}

sub stripPath {
	my($s)=shift;
	my($path)=shift;
	my($pre)=$s->base->cleanPath($s->{_path_prefix});
	$path=~s!^$pre/?!!;
	$path
}

sub getList {
	my($s)=shift;
	my($dir)=shift||"";
	my($path)=(!$dir)?$s->{_path_prefix}:"$s->{_path_prefix}/$dir";
	$path=$s->base->cleanPath($path);
	my(@list,$content);
	my($lastpath)=($s->stripPath($path)=~m/(.+)\/[^\/]+\/?$/);
	$lastpath.="/" if($lastpath);
	push(@list,{file=>"../",url=>"$s->{_base}->{_self}/$lastpath",size=>"-",type=>"gif",img=>"dir",description=>"back to parent directory"}) if($dir);
	foreach(<$path/*>) {
		next if(m/^\./||m/\.desc$/);
		my($file)=$s->stripPath($_);
		my(@info)=stat($_);
		my($desc);
		if(-e "$_.desc") {
			open(DESC,"$_.desc");
			$desc=join("",($_=~/(.+)[\r\n]*/),$desc) foreach(<DESC>);
			close(DESC);
		}
		if(-d $_) {
			my($dpath)=$file;
			if($file=~m!/!) {
				($dpath)=($file=~m!.+/([^/]+)!);
			}
			push(@list,{file=>"$dpath/",url=>"/".$s->base->cleanPath("$s->{_base}->{_self}/$file/"),size=>"-",type=>"gif",img=>"dir",description=>$desc})
		}
		else {
			my($dpath,$fpath)=("",$file);
			if($file=~m!/!) {
				($dpath)=($file=~m!(.+)/[^/]+!);
				($fpath)=($file=~m!.+/(.+)!);
				$dpath.="/";
			}
			push(@list,{file=>$fpath,url=>"/".$s->base->cleanPath("$s->{_base}->{_self}/$dpath$fpath"),size=>"$info[7] byte",type=>"gif",img=>"patch",description=>$desc});
		}
	}
	my($t)=HTML::Template->new(filename=>"./skins/$s->{_base}->{_skin}/$s->{_template}.html");
	$t->param(LIST=>[@list]);
	$content->{title}="$s->{_name}: /".$s->stripPath($path)."";
	$content->{description}="$s->{_name}: /".$s->stripPath($path)."";
	$content->{content}=$t->output;
	$content
}

sub printFile {
	my($s)=shift;
	my($dir,$file)=@_;
	my($path)=$s->base->cleanPath("$dir/$file");
	if(!-e "$s->{_path_prefix}/$path") {
		return
	}
	my($types)=MIME::Types->new;
	my($mime)=$types->mimeTypeOf($file);
	print "Content-type: $mime\n\n";
	open(PATCH,"$s->{_path_prefix}/$path");
	print foreach(<PATCH>);
	close(PATCH);
}

sub checkFile {
	my($s)=shift;
	my($dir)=shift;
	my($file)=shift;
	my($path)=(!$dir)?"$s->{_path_prefix}/$file":"$s->{_path_prefix}/$dir/$file";
	$path=$s->base->cleanPath($path);
	return 0 if(-d $path);
	(-e $path)?1:0
}

sub checkDir {
	my($s)=shift;
	my($dir)=shift;
	my($file)=shift;
	my($path)=(!$dir)?"$s->{_path_prefix}/$file":"$s->{_path_prefix}/$dir/$file";
	$path=$s->base->cleanPath($path);
	(-d $path)?1:0
}

1;

package HMS::Images;
use strict;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use Image::Size qw(attr_imgsize);

sub new {
	my($c)=shift;
	my($s)={
		_base		=> ${$_[0]},
	};
	bless($s,$c)
}

sub base { $_[0]->{_base} }
sub xml { $_[0]->{_base}->{_xml} }

sub setPathPrefix { $_[0]->{_path_prefix}=$_[1] }
sub setName { $_[0]->{_name}=$_[1] }
sub setTemplate { $_[0]->{_template}=$_[1] }

sub loadPage {
	my($s)=shift;
	my($page)=shift||"";
	my($content)=$s->getList($page);
	print "Content-type: text/html\n\n".$s->base->loadTemplate($content);

}

sub stripPath {
	my($s)=shift;
	my($path)=shift;
	my($pre)=$s->base->cleanPath($s->{_path_prefix});
	$path=~s!^$pre/?!!;
	$path
}

sub getList {
	my($s)=shift;
	my($dir)=shift||"";
	my($path)=(!$dir)?$s->{_path_prefix}:"$s->{_path_prefix}/$dir";
	$path=$s->base->cleanPath($path);
	my(@list,$content);
	my($lastpath)=($s->stripPath($path)=~m/(.+)\/[^\/]+\/?$/);
	$lastpath.="/" if($lastpath);
	push(@list,{file=>"../",url=>"$s->{_base}->{_self}/$lastpath",size=>"-",type=>"gif",img=>"dir",description=>"back to parent directory"}) if($dir);
	foreach(<$path/*>) {
		next if(m/^\./||m/\.desc$/);
		my($file)=$s->stripPath($_);
		my(@info)=stat($_);
		my(@img)=attr_imgsize($_) if($_=~/(png|gif|jpeg|jpg)/);
		my($desc);
		if(-e "$_.desc") {
			open(DESC,"$_.desc");
			$desc=join("",($_=~/(.+)[\r\n]*/),$desc) foreach(<DESC>);
			close(DESC);
		}
		if(-d $_) {
			my($dpath)=$file;
			if($file=~m!/!) {
				($dpath)=($file=~m!.+/([^/]+)!);
			}
			push(@list,{file=>"$dpath/",url=>"$s->{_base}->{_self}/$file/",size=>"-",type=>"gif",img=>"dir",description=>$desc})
		}
		else {
			my($dpath,$fpath)=("",$file);
			if($file=~m!/!) {
				($dpath)=($file=~m!(.+)/[^/]+!);
				($fpath)=($file=~m!.+/(.+)!);
				$dpath.="/";
			}
			my($ext)=($fpath=~m/\.(png|gif|jpg|jpeg)$/);
			$fpath=~s/\.(png|gif|jpg|jpeg)$//;
			push(@list,{file=>"$fpath.$ext",url=>"$s->{_base}->{_self}/view/$ext/$dpath$fpath",size=>"$img[1]x$img[3] pixel, ".sprintf("%.2f",($info[7]/1024))." kbyte",type=>"gif",img=>"image2",description=>$desc})
		}
	}
	my($t)=HTML::Template->new(filename=>"./skins/$s->{_base}->{_skin}/$s->{_template}.html");
	$t->param(LIST=>[@list]);
	$content->{title}="$s->{_name}: /".$s->stripPath($path)."";
	$content->{description}="$s->{_name}: /".$s->stripPath($path)."";
	$content->{content}=$t->output;
	$content
}

sub showFile {
	my($s)=shift;
	my($file,$type)=@_;
	my($path)=$s->base->cleanPath("$s->{_path_prefix}/$file.$type");
	if(!-e $path) {
		return
	}
	my($desc);
	if(-e "$path.desc") {
		open(DESC,"$path.desc");
		$desc=join("",($_=~/(.+)[\r\n]*/),$desc) foreach(<DESC>);
		close(DESC);
	}
	my($content);
	my($t)=HTML::Template->new(filename=>"./skins/$s->{_base}->{_skin}/$s->{_template}.html");
	$t->param(
		TYPE		=> $type,
		IMAGE		=> $s->base->cleanPath("$file"),
		DESCRIPTION	=> $desc,
	);
	$content->{title}="$s->{_name}: /".$s->stripPath($path)."";
	$content->{description}="$s->{_name}: /".$s->stripPath($path)."";
	$content->{content}=$t->output;
	print "Content-type: text/html\n\n".$s->base->loadTemplate($content);
}

sub printFile {
	my($s)=shift;
	my($file,$type)=@_;
	my($path)=$s->base->cleanPath("$s->{_path_prefix}/$file.$type");
	if(!-e $path) {
		return
	}
	print "Content-type: image/$type\n\n";
	open(IMAGE,$path);
	print foreach(<IMAGE>);
	close(IMAGE);
}

sub checkFile {
	my($s)=shift;
	my($path)=@_;
	$path="$s->{_path_prefix}/$path";
	$path=$s->base->cleanPath($path);
	(-e $path)?1:0
}

1;

package HMS::Links;
use strict;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use POSIX;

sub new {
	my($c)=shift;
	my($s)={
		_base		=> ${$_[0]},
	};
	bless($s,$c)
}

sub base { $_[0]->{_base} }
sub xml { $_[0]->{_base}->{_xml} }

sub setPathPrefix { $_[0]->{_path_prefix}=$_[1] }
sub setName { $_[0]->{_name}=$_[1] }
sub setTemplate { $_[0]->{_template}=$_[1] }

sub loadPage {
	my($s)=shift;
	my($sub)=@_;
	my($content)=$s->getLinksTree($sub);
	print "Content-type: text/html\n\n".$s->base->loadTemplate($content);
}

sub getLinksTree {
	my($s)=shift;
        my($sub,$lev,$path)=@_;
        my($content);
        my($pre_sub)="<ol type=\"disc\" style=\"color: red\">\n";
        my($pre_link)="<ol type=\"square\" style=\"color: blue\">\n";
        my($app)="</ol>\n";

	if(!$sub) {
		my($doc)=$s->base->xml->XMLin("$s->{_path_prefix}/links.xml",forcearray=>1,keyattr=>[],parseropts=>[ErrorContext=>2]);
		$s->{_tmp_refhelp}=0;
		$s->{_tmp_links}=0;
		$sub=$doc->{links}->[0]->{group};
		$s->{_tmp_description}=$doc->{content};
	}
	$lev=1 if(!$lev);
        $content->{content}=$pre_sub if($lev==1);

	foreach(@{$sub}) {
		$s->{_tmp_refhelp}++;
		$content->{content}.="  "x$lev."<li><a name=\"$s->{_tmp_refhelp}\"/><b><a href=\"$s->{_base}->{_self}${path}/$_->{name}#$s->{_tmp_refhelp}\">$_->{name} (".($#{$_->{link}}+1).")</a></b>\n";
		$lev++;
		$s->{_tmp_links}++ foreach(@{$_->{link}});
		if($_->{group}->[0]) {
			$content->{content}.="  "x$lev.$pre_sub;
			$content->{content}.=$s->getLinksTree($_->{group},($lev+1),"${path}/$_->{name}");
			$content->{content}.="  "x$lev.$app;
                }
		if($_->{link}->[0] && "$path/$_->{name}" eq "/".$s->base->cgi->param("section")) {
			$content->{content}.="  "x$lev.$pre_link;
			foreach(@{$_->{link}}) {
				$content->{content}.="  "x$lev."  <li><a href=\"$_->{url}\">$_->{name}</a></li>\n";
			}
			$content->{content}.="  "x$lev.$app;
		}
		$lev--;
		$content->{content}.="  "x$lev."</li>\n";
	}
	if($lev==1) {
		$content->{content}.=$app;
		my($sec,$min,$hour,$mday,$mon,$year)=split(/,/,POSIX::strftime("%S,%M,%H,%d,%m,%Y",localtime((stat("$s->{_path_prefix}/links.xml"))[10])));
		
		$content->{content}=$s->{_tmp_description}."$s->{_tmp_links}<br />".$content->{content}."Last update: $year/$mon/$mday $hour:$min:$sec";
		$content->{title}=$s->{_name}.": /".$s->base->cgi->param("section");
		return $content
	}
	return $content->{content}
}

1;

